"Include this generated file after function definitions"


import BuiltIn
import os
import sys

BANDAID_LIST = ["rpc", "mcastRpc", "saveNvParam", "resetVm", "eraseImage",
    "writeChunk", "initVm", "rpcSourceAddr", "stdinMode", "chr", "cbusRd",
    "i2cRead", "spiRead", "spiXfer", "str", "vmStat", "updateDmxBuf"]

def decorate(name):
    "Apply C-code 'pyWrapper' naming convention"
    return 'py' + name[0].upper() + name[1:]


if __name__ == "__main__":
    varname = 'const pyCFuncTbl'
    if len(sys.argv) > 1:
      os.chdir(os.path.realpath(sys.argv[1]))

    cf = BuiltIn.__cfuncs__.items()
    cf.sort(key=lambda x: x[1])
    fp = open('pyCFuncTbl.c', 'wb')
    buf = '// Generated by genCFuncWrapTbl.py\r\n#include "Knobs.h"\r\n\r\n'
    for nm,info in cf:
        bandaid = " BANDAID" if nm in BANDAID_LIST else ""
        buf += "extern void %s(unsigned char nArgs)%s;\r\n" % (decorate(nm), bandaid)

    buf += "\r\ntypedef void (*PyFuncWrap)(unsigned char nArgs);\r\n\r\n"

    buf += "// If not a DMX build, make the pyBist() stub fill in as DMX stubs too\r\n"
    buf += "#ifndef WITH_DMX\r\n"
    buf += "#define pyUpdateDmxBuf   pyBist\r\n"
    buf += "#define pyGetDmxBuf      pyBist\r\n"
    buf += "#endif\r\n\r\n"

    buf += "DECL_ROM PyFuncWrap %s[] = {\r\n" % varname
    for nm,info in cf:
        buf += ''.join(["  %-15s,  // %i\r\n" % (decorate(nm),info)])
        if nm == "vmStat":
            vmStatId = info
    buf += "};\r\n"

    buf += "\r\n#define VM_STAT_ID   %d\r\n" % vmStatId

    fp.write(buf)
    fp.close()
